# $Revision: 1.24 $, $Date: 2009/11/17 10:02:09 $
# TODO
# - update paths in manuals (create .in files and send upstream)
# - make /etc/pam.d independant of sysconfdir (configure-able option and send upstream)
# - https://fedorahosted.org/cronie/changeset/272c4a5c417bfa6e04148fc35a4fe4c6956b17e1
#   should we follow it too? our pam contains cron.{allow,deny} listfile rules,
#   cronie itself checks these files so safe to drop?
#
# Conditional build:
%bcond_without	inotify		# without inotify support
%if "%{pld_release}" == "ac"
%bcond_with		selinux		# without SELinux support
%bcond_with		audit		# without audit support
%else
%bcond_without	selinux		# without SELinux support
%bcond_without	audit		# without audit support
%endif

Summary:	Cron daemon for executing programs at set times
Name:		cronie
Version:	1.4.3
Release:	1
License:	MIT and BSD and GPL v2
Group:		Daemons
Source0:	https://fedorahosted.org/releases/c/r/cronie/%{name}-%{version}.tar.gz
# Source0-md5:	2393b3e5828fc09d9acf04dfd7796ab9
Source1:	%{name}.init
Source2:	cron.logrotate
Source3:	cron.sysconfig
Source4:	%{name}.crontab
Source5:	%{name}.pam
Patch0:		inotify-nosys.patch
Patch1:		%{name}-nosyscrontab.patch
Patch2:		sendmail-path.patch
URL:		https://fedorahosted.org/cronie/
%{?with_audit:BuildRequires:	audit-libs-devel}
BuildRequires:	autoconf
BuildRequires:	automake
%{?with_selinux:BuildRequires:	libselinux-devel}
BuildRequires:	pam-devel
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	rpmbuild(macros) >= 1.268
Requires(post):	fileutils
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires:	/bin/run-parts
Requires:	/sbin/chkconfig
Requires:	psmisc >= 20.1
Requires:	rc-scripts >= 0.4.0.19
%{?with_inotify:Requires:	uname(release) >= 2.6.13}
Provides:	crondaemon
Provides:	crontabs = 1.7
Provides:	group(crontab)
%if "%{pld_release}" == "th"
Provides:	vixie-cron = 4:4.4
%endif
Obsoletes:	crondaemon
Obsoletes:	crontabs
%if "%{pld_release}" == "th"
Obsoletes:	vixie-cron <= 4:4.3
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Cronie contains the standard UNIX daemon crond that runs specified
programs at scheduled times and related tools. It is based on the
original cron and has security and configuration enhancements like the
ability to use pam and SELinux.

%package anacron
Summary:	Utility for running regular jobs
Group:		Base
Provides:	anacron = 2.4
Obsoletes:	anacron <= 2.3

%description anacron
Anacron becames part of cronie. Anacron is used only for running
regular jobs. The default settings execute regular jobs by anacron,
however this could be overloaded in settings.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	SYSCRONTAB=/etc/crontab \
	SYS_CROND_DIR=/etc/cron.d \
	--sysconfdir=/etc/cron \
	--with-pam \
	--with%{!?with_selinux:out}-selinux \
	--with%{!?with_audit:out}-audit \
	--with%{!?with_inotify:out}-inotify \
	--enable-anacron

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/var/{log,spool/{ana,}cron},%{_mandir}} \
	$RPM_BUILD_ROOT/etc/{rc.d/init.d,logrotate.d,sysconfig} \
	$RPM_BUILD_ROOT%{_sysconfdir}/{cron,cron.{d,hourly,daily,weekly,monthly},pam.d}

%{__make} install \
	pamdir=/etc/pam.d \
	DESTDIR=$RPM_BUILD_ROOT

install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/crond
cp -a contrib/0anacron $RPM_BUILD_ROOT/etc/cron.hourly/0anacron
cp -a %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/cron
cp -a %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/cron
cp -a %{SOURCE4} $RPM_BUILD_ROOT/etc/cron.d/crontab
cp -a %{SOURCE5} $RPM_BUILD_ROOT/etc/pam.d/crond

touch $RPM_BUILD_ROOT/var/log/cron

cat > $RPM_BUILD_ROOT%{_sysconfdir}/cron/cron.allow << 'EOF'
# cron.allow	This file describes the names of the users which are
#		allowed to use the local cron daemon
root
EOF

cat > $RPM_BUILD_ROOT%{_sysconfdir}/cron/cron.deny << 'EOF'
# cron.deny	This file describes the names of the users which are
#		NOT allowed to use the local cron daemon
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 117 -r -f crontab

%post
if [ ! -f /var/log/cron ]; then
	umask 027
	touch /var/log/cron
	chgrp crontab /var/log/cron
	chmod 660 /var/log/cron
fi
/sbin/chkconfig --add crond
%service crond restart "Cron Daemon"

%preun
if [ "$1" = "0" ]; then
	%service crond stop
	/sbin/chkconfig --del crond
fi

%postun
if [ "$1" = "0" ]; then
	%groupremove crontab
fi

%triggerpostun -- hc-cron
# reinstall crond init.d links, which could be different
/sbin/chkconfig --del crond
/sbin/chkconfig --add crond

%triggerun -- vixie-cron
# Prevent preun from crond from working
chmod a-x /etc/rc.d/init.d/crond

%triggerpostun -- vixie-cron
# Restore what triggerun removed
chmod 754 /etc/rc.d/init.d/crond
/sbin/chkconfig --add crond

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog README
%attr(750,root,crontab) %dir %{_sysconfdir}/cron*
%attr(640,root,crontab) %config(noreplace,missingok) /etc/cron.d/crontab
%attr(640,root,crontab) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/cron/cron.allow
%attr(640,root,crontab) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/cron/cron.deny
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/cron
%config(noreplace) %verify(not md5 mtime size) /etc/pam.d/crond
%attr(754,root,root) /etc/rc.d/init.d/crond
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/cron
%attr(755,root,root) %{_sbindir}/crond
%attr(2755,root,crontab) %{_bindir}/crontab

%{_mandir}/man8/crond.8*
%{_mandir}/man8/cron.8*
%{_mandir}/man5/crontab.5*
%{_mandir}/man1/crontab.1*

%attr(1730,root,crontab) /var/spool/cron
%attr(660,root,crontab) %ghost /var/log/cron

%files anacron
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/anacron
%attr(755,root,root) %{_sysconfdir}/cron.hourly/0anacron
%{_mandir}/man5/anacrontab.5*
%{_mandir}/man8/anacron.8*

%attr(1730,root,crontab) /var/spool/anacron

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: cronie.spec,v $
Revision 1.24  2009/11/17 10:02:09  glen
- status --pidfile dep in initscript

Revision 1.23  2009/11/17 08:51:04  glen
- up to 1.4.3

Revision 1.22  2009/11/17 06:15:56  glen
- use /usr/lib/sendmail for sendmail path; rel 2

Revision 1.21  2009/10/28 18:15:19  glen
- todo toughts

Revision 1.20  2009/10/28 18:06:43  glen
- update to 1.4.2

Revision 1.19  2009/09/09 13:03:39  arekm
- rel 7; no /etc/crontab processing

Revision 1.18  2009/08/27 07:06:53  arekm
- rel 6; leave syscrontab as /etc/crontab. /etc/cron.d/crontab will be still
  processed by cron.d/ dir rule and we don't want for it to be processed twice.

Revision 1.17  2009/08/18 10:54:19  arekm
- release 5

Revision 1.16  2009/08/18 09:22:48  arekm
- release 4

Revision 1.15  2009/08/13 16:11:13  glen
- few todo

Revision 1.14  2009/08/13 15:53:00  glen
- fix pam dir on install, disable selinux,audit on ac (need more work)

Revision 1.13  2009/08/13 11:34:20  hawk
- don't provide/obsolete vixie-cron on Titanium

Revision 1.12  2009/08/13 10:59:00  glen
- add inotify interface if it's missing in glibc but kernel has it

Revision 1.11  2009/08/13 10:43:58  glen
- audit bcond, regen automake

Revision 1.10  2009/08/13 10:31:39  glen
- inotify bcond and glibc interface dep

Revision 1.9  2009/08/12 08:27:21  glen
- bcond fix

Revision 1.8  2009/08/11 21:08:27  arekm
- rel 2; add /var/spool/anacron

Revision 1.7  2009/08/11 20:59:08  arekm
- upload via dropin

Revision 1.6  2009/08/11 20:53:30  arekm
- rel 1; works for me

Revision 1.5  2009/08/11 20:49:31  arekm
- sysconf path fixed

Revision 1.4  2009/08/11 20:23:42  arekm
- add vixie-cron trigger

Revision 1.3  2009/08/11 20:18:54  arekm
- supported way is to set via configure visible vars

Revision 1.2  2009/08/11 20:07:52  arekm
- pldize paths

Revision 1.1  2009/08/11 20:04:59  arekm
- initial
